using System;
using System.Collections.Generic;
using System.Text;

using System.ComponentModel;

namespace HP
{
    public class BackgroundWorkerManage
    {
        private class BackgroundWorkerData
        {
            /// <summary>
            /// RunWorkerAsync ĂяoꂽƂɔ܂B
            /// </summary>
            public DoWorkEventHandler DoWork = null;
            /// <summary>
            /// BackgroundWorker NX RunWorkerCompleted Cxg郁\bh\܂B
            /// </summary>
            public RunWorkerCompletedEventHandler RunworkerCompleted = null;
            /// <summary>
            /// V[PXԍłB
            /// </summary>
            public long SeqNo = 0;
            /// <summary>
            /// Ŏg܂B
            /// </summary>
            public object Obj = null;

            /// <summary>
            /// RXgN^
            /// </summary>
            /// <param name="doWork">DoWorkEventHandler</param>
            /// <param name="completed">RunWorkerCompletedEventHandler</param>
            /// <param name="seqNo">V[PXԍ</param>
            public BackgroundWorkerData(DoWorkEventHandler doWork, RunWorkerCompletedEventHandler completed, long seqNo)
            {
                DoWork = doWork;
                RunworkerCompleted = completed;
                SeqNo = seqNo;
            }
            /// <summary>
            /// RXgN^
            /// </summary>
            /// <param name="doWork">DoWorkEventHandler</param>
            /// <param name="completed">RunWorkerCompletedEventHandler</param>
            /// <param name="seqNo">V[PXԍ</param>
            public BackgroundWorkerData(DoWorkEventHandler doWork, RunWorkerCompletedEventHandler completed, long seqNo, object obj)
            {
                DoWork = doWork;
                RunworkerCompleted = completed;
                SeqNo = seqNo;
                Obj = obj;
            }
        }

        /// <summary>
        /// obNOEh
        /// </summary>
        private BackgroundWorker _bgw = new BackgroundWorker();

        /// <summary>
        /// obNOEhƎsɌĂяoǗ܂B
        /// </summary>
        private List<BackgroundWorkerData> _data = new List<BackgroundWorkerData>();

        /// <summary>
        /// BackgroundWorkerDataIuWFNgo^邽т+1܂B
        /// </summary>
        private long _seqNo = 1;

        /// <summary>
        /// RXgN^
        /// </summary>
        public BackgroundWorkerManage()
        {
            ;
        }

        /// <summary>
        /// LZꂽǂ肷lłB
        /// true:LZ false:LZĂȂ
        /// </summary>
        public bool IsCancel
        {
            get { return _bgw.CancellationPending; }
        }

        /// <summary>
        /// obNOEhŎs鏈o^As̃obNOEhȂ΂Ɏs܂B
        /// słȂꍇ͌ݎsĂobNOEhIɎs܂B
        /// </summary>
        /// <param name="doWork">DoWorkEventHandler</param>
        /// <param name="completed">RunWorkerCompletedEventHandler</param>
        public void Run(DoWorkEventHandler doWork, RunWorkerCompletedEventHandler completed)
        {
            // doWorknull̏ꍇ̓R[fBO~XƔf܂B
            if (doWork == null) { return; }

            // o^܂B
            _data.Add(new BackgroundWorkerData(doWork, completed, _seqNo));
            //Console.WriteLine("o^[" + _seqNo + "]");
            _seqNo++;
            if (999999 < _seqNo) { _seqNo = 1; }

            // ŝƂ͏܂B
            if (!_bgw.IsBusy)
            {
                //Console.WriteLine("s[" + _data[0].SeqNo + "]");
                _bgw.DoWork += new DoWorkEventHandler(_data[0].DoWork);
                if (_data[0].RunworkerCompleted != null)
                {
                    _bgw.RunWorkerCompleted += new RunWorkerCompletedEventHandler(_data[0].RunworkerCompleted);
                }
                _bgw.RunWorkerCompleted += new RunWorkerCompletedEventHandler(NextRun);
                _bgw.WorkerSupportsCancellation = true;

                // obNOEh̎sJn܂B
                _bgw.RunWorkerAsync();
            }
        }
        /// <summary>
        /// obNOEhŎs鏈o^As̃obNOEhȂ΂Ɏs܂B
        /// słȂꍇ͌ݎsĂobNOEhIɎs܂B
        /// </summary>
        /// <param name="doWork">DoWorkEventHandler</param>
        /// <param name="completed">RunWorkerCompletedEventHandler</param>
        /// <param name="obj"></param>
        public void Run(DoWorkEventHandler doWork, RunWorkerCompletedEventHandler completed, object obj)
        {
            // doWorknull̏ꍇ̓R[fBO~XƔf܂B
            if (doWork == null) { return; }

            // o^܂B
            _data.Add(new BackgroundWorkerData(doWork, completed, _seqNo, obj));
            //Console.WriteLine("o^[" + _seqNo + "]");
            _seqNo++;
            if (999999 < _seqNo) { _seqNo = 1; }

            // ŝƂ͏܂B
            if (!_bgw.IsBusy)
            {
                //Console.WriteLine("s[" + _data[0].SeqNo + "]");
                _bgw.DoWork += new DoWorkEventHandler(_data[0].DoWork);
                if (_data[0].RunworkerCompleted != null)
                {
                    _bgw.RunWorkerCompleted += new RunWorkerCompletedEventHandler(_data[0].RunworkerCompleted);
                }
                _bgw.RunWorkerCompleted += new RunWorkerCompletedEventHandler(NextRun);
                _bgw.WorkerSupportsCancellation = true;

                if (obj != null)
                {
                    // obNOEh̎sJn܂B
                    _bgw.RunWorkerAsync(obj);
                }
                else
                {
                    // obNOEh̎sJn܂B
                    _bgw.RunWorkerAsync();
                }
            }
        }

        /// <summary>
        /// obNOEh̃LZv܂B
        /// ̃\bhsIsCancelvpeBtrueƂȂ܂B
        /// </summary>
        public void Cancel()
        {
            _bgw.CancelAsync();
        }

        /// <summary>
        /// ̃obNOEhs܂B
        /// </summary>
        /// <param name="sender">CxgIuWFNg</param>
        /// <param name="e">RunWorkerCompletedEventArgs</param>
        private void NextRun(object sender, RunWorkerCompletedEventArgs e)
        {
            // Cxg폜
            _bgw.DoWork -= new DoWorkEventHandler(_data[0].DoWork);
            if (_data[0].RunworkerCompleted != null)
            {
                _bgw.RunWorkerCompleted -= new RunWorkerCompletedEventHandler(_data[0].RunworkerCompleted);
            }
            _bgw.RunWorkerCompleted -= new RunWorkerCompletedEventHandler(NextRun);

            _data.RemoveAt(0);

            // o^Ă̂Ύs܂B
            if (0 < _data.Count)
            {
                //Console.WriteLine("s[" + _data[0].SeqNo + "]");
                _bgw.DoWork += new DoWorkEventHandler(_data[0].DoWork);
                if (_data[0].RunworkerCompleted != null)
                {
                    _bgw.RunWorkerCompleted += new RunWorkerCompletedEventHandler(_data[0].RunworkerCompleted);
                }
                _bgw.RunWorkerCompleted += new RunWorkerCompletedEventHandler(NextRun);
                _bgw.WorkerSupportsCancellation = true;

                if (_data[0].Obj != null)
                {
                    // obNOEh̎sJn܂B
                    _bgw.RunWorkerAsync(_data[0].Obj);
                }
                else
                {
                    // obNOEh̎sJn܂B
                    _bgw.RunWorkerAsync();
                }
            }
        }
    }
}
